<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use HCM\Util\DateUtil;
 
class FpagrrfmagnetEntity extends TkEntity
{   
    public function __construct($entityManager, $hcmParameters) {
        $this->hcmParameters = $hcmParameters;
        $this->grrfMagnet = Repositories::FPA_GRRFMAGNET;
        parent::__construct(null, $entityManager);
    }
    
    public function retornaFgtsMesAnterior($nrvinculom, $nrorg, $dtinicio, $dtfim){
        return $this->entityManager->getRepository(Repositories::FPA_GRRFMAGNET)->getFgtsMesAnterior($nrvinculom, $nrorg, $dtinicio, $dtfim);
    }

    public function retornaRegistros($mesCompetencia, $nrOrg, $cdOperador){
        return $this->entityManager->getRepository(Repositories::FPA_GRRFMAGNET)->retornaRegistros($mesCompetencia, $nrOrg, $cdOperador);
    }

    public function inicializaListaRegistros($mesCompetencia, $listaTipoRegistro, $nrOrg, $cdOperador){
        $resultados = $this->entityManager->getRepository(Repositories::FPA_GRRFMAGNET)->retornaRegistrosPorTipo($mesCompetencia, $listaTipoRegistro, $nrOrg, $cdOperador);
        if (is_array($resultados) === true) {
            foreach ($resultados as $resultado) {
                $this->addItem($resultado, $resultado->getNrgrrfmagnet());
            }
            return true;
        } else {
            return false;
        }
    }

    public function insereRegistroLista($nrOrg, $cdOperador, $mesCompetencia, $tipoRegistro, $tipoInscricao, $nrInscricao, $linha,
        $tipoInscricaoTom = "0", $nrInscricaoTom = "0", $nrVinculo = null, $dtAdmissao = null, $nrPisPasepCi = "0",
        $vrSalarioFamilia = null, $vrSalarioMaternidade = null, $categoriaTrabalhador = null, $fgtsmesanterior){

        $item = new $this->grrfMagnet;
        $item->setIdativo('S');
        $item->setNrorg($nrOrg);
        $item->setCdoperinclusao($cdOperador);
        $item->setMescompetencia($mesCompetencia);
        $item->setIdtiporegistro($tipoRegistro);
        $item->setIdtpinscestrutu($tipoInscricao);
        $item->setCdinscestrut($nrInscricao);
        $item->setDslinharegistro($linha);
        $item->setIdtpinscesttoma($tipoInscricaoTom);
        $item->setCdinscestrutoma($nrInscricaoTom);
        $item->setNrvinculom($nrVinculo);
        $item->setDtadmissaovinc($dtAdmissao);
        $item->setNrpispaseppes($nrPisPasepCi);
        $item->setVrsalfamilia($vrSalarioFamilia);
        $item->setVrsalmaternidad($vrSalarioMaternidade);
        $item->setIdcategtrab($categoriaTrabalhador);
        $item->setFgtsmesanterior($fgtsmesanterior);
        
        $item->setDtinclusao(DateUtil::getDataAtual());
        $item->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $item->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $item->setDtultatu(DateUtil::getDataAtual());
        $item->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $item->setCdoperultatu($this->hcmParameters->getCdoperador());
        $item->setNrgrrfmagnet(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'FPA_GRRFMAGNET', 1, 12, true));
        $this->addItem($item);

    }

    public function persisteRegistro($nrOrg, $cdOperador, $mesCompetencia, $tipoRegistro, $tipoInscricao, $nrInscricao, $linha,
        $nrVinculoM, $dataAdmissao, $nrPisPasepCi, $categoriaTrabalhador, $fgtsmesanterior){

        $item = $this->entityManager->getRepository(Repositories::FPA_GRRFMAGNET)->retornaRegistrosTrabalhador($mesCompetencia, $cdOperador, $nrOrg, $tipoRegistro, $tipoInscricao, $nrInscricao, $nrPisPasepCi, $dataAdmissao, $categoriaTrabalhador);

        if (is_object($item) === true) {
            $item->setNrgrrfmagnet($item->getNrgrrfmagnet());
            $item->setDslinharegistro($linha);
        } else {
            $item = new $this->grrfMagnet;
            $item->setIdativo('S');
            $item->setNrorg($nrOrg);
            $item->setCdoperinclusao($cdOperador);
            $item->setMescompetencia($mesCompetencia);
            $item->setIdtiporegistro($tipoRegistro);
            $item->setIdtpinscestrutu($tipoInscricao);
            $item->setCdinscestrut($nrInscricao);
            $item->setNrvinculom($nrVinculoM);
            $item->setDtadmissaovinc($dataAdmissao);
            $item->setNrpispaseppes($nrPisPasepCi);
            $item->setNrgrrfmagnet(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'FPA_GRRFMAGNET', 1, 12, true));
            $item->setIdcategtrab($categoriaTrabalhador);
            $item->setFgtsmesanterior($fgtsmesanterior);
            $item->setDslinharegistro($linha);
            $item->setDtinclusao(DateUtil::getDataAtual());
            $item->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
            $item->setCdoperinclusao($this->hcmParameters->getCdoperador());
            $item->setDtultatu(DateUtil::getDataAtual());
            $item->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
            $item->setCdoperultatu($this->hcmParameters->getCdoperador());
        }
        $this->entityManager->persist($item);
        $this->entityManager->flush($item);
    }
    
    public function procuraRegistroLista($nrInscricao, $nrInscricaoTom, $nrRegistro) {
        $itens = $this->getItems();
        foreach ($itens as $key => $item) {
            if (($item->getCdinscestrut() === $nrInscricao)
                && ($item->getCdinscestrutoma() === $nrInscricaoTom)
                && ($item->getIdtiporegistro() === $nrRegistro)
            ) {
                return $key;
            }
        }
        return false;
    }

    public function retroceder($nrOrg, $cdOperador, $mesCompetencia){
        $this->entityManager->getRepository(Repositories::FPA_GRRFMAGNET)->retroceder($mesCompetencia, $nrOrg, $cdOperador);
        /*$registros = $this->retornaRegistros($mesCompetencia, $nrOrg, $cdOperador);
        if (count($registros) > 0) {
            $this->entityManager->beginTransaction();
            foreach ($registros as $registro) {
                $this->entityManager->remove($registro);
                $this->entityManager->flush();
            }
            $this->entityManager->commit();
        }*/
    }
}