<?php
namespace HCM\Geral\Controllers;

use HCM\Geral\Services\PreFechamentoDctfWebService;
use HCM\Util\HCMParameters;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;

class PreFechamentoDctfWebController 
{
    public function __construct (HCMParameters $hcmParameters, PreFechamentoDctfWebService $preFechamentoDctfWebService)
    {
        $this->hcmParameters = $hcmParameters;
        $this->preFechamentoDctfWebService = $preFechamentoDctfWebService;
    }
    
    public function getContribuicaoPrevidenciariaSegurado(DTO\Request\DataSet $request, DTO\Response $response)
    {
        try
        {
            $parameters = array( 'NRORG'          => $request->getDataSet()->getRows()[0]['NRORG'],
                                 'NRESTRUTGEREN'  => isset($request->getDataSet()->getRows()[0]['NRESTRUTGEREN']) ? $request->getDataSet()->getRows()[0]['NRESTRUTGEREN'] : '',
                                 'DTMESCOMPETENC' => $request->getDataSet()->getRows()[0]['DATACOMPETENCIAINICIAL'],
                                 'NRESTRUTLEGAL'  => isset($request->getDataSet()->getRows()[0]['NRESTRUTLEGAL_LIST']) ? $request->getDataSet()->getRows()[0]['NRESTRUTLEGAL_LIST'] : '',
                                 'NRTABELA'       => isset($request->getDataSet()->getRows()[0]['APURACAO']) ? $request->getDataSet()->getRows()[0]['APURACAO'] : null );

            $dataSet = $this->preFechamentoDctfWebService->getContribuicaoPrevidenciariaSegurado($parameters);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('dataset', $dataSet));
        }
        catch(\Exception $e) 
        {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
} 