<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class PreFechamentoDctfWebRepository
{
    public function __construct(Connection $connection, EntityManager $entityManager)
    {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }
    
    static $queryContribuicaoPrevidenciaria = "
        SELECT * FROM (SELECT RES.VINCULO,
            RES.DTRESCISAOVINC,
            RES.MATRICULA,
            RES.REGISTRO,
            PE.NRCPFPESSOA,
            RES.NOME,
            RES.NRLEGAL,
            RES.NRGEREN,
            RES.RAZAOLEGAL,
            RES.CNPJLEGAL,
            RES.INTLEGAL,
            RES.RAZAOGEREN,
            RES.CNPJGEREN,
            RES.INTGEREN,
            SUM(ENVIO.VRDESCONTADO) VRDESC_ESO,
            SUM(ENVIO.VRCALCULADO)  VRCALCULADO_ESO,
            SUM((NVL(ENVIO.VRBASE13,0)+NVL(ENVIO.VRBASEMENSAL,0))) VRBASE_ESO,
            RES.BASE,
            RES.INSS,
            ENVIO.IDSTATUS,
            ENVIO.NRTABELA,
            RES.BASE - SUM((NVL(ENVIO.VRBASE13,0)+NVL(ENVIO.VRBASEMENSAL,0))) DIFERENCA_BASE,
            RES.INSS - SUM(ENVIO.VRCALCULADO) DIFERENCA_DESCONTO
               FROM (SELECT
                        VM.NRORG, VM.NRPESSOA,
                        VM.NRVINCULOM      VINCULO,
                        VM.DTRESCISAOVINC,
                        VM.CDMATRICULA     MATRICULA,
                        VM.DSLIVROADMISSAO REGISTRO,
                        VM.NMVINCULOM      NOME,
                        /*ICF.NREVENTOM      EVENTO,*/
                        SUM(CASE WHEN ICF.NREVENTOM IN (3070 ,3075 ,3130, 3190, 3211, 4010) THEN ICF.VREVENTOFOLHA ELSE 0 END) BASE,
                        SUM(CASE WHEN ICF.NREVENTOM IN (1130, 1160, 1150, 1180, 1200, 4000/*, 1140, 1190*/) THEN ICF.VREVENTOFOLHA ELSE 0 END) INSS,
                        CF.DTOCORRENCIA,
                        VH.NRESTRUTLEGAL   NRLEGAL,
                        VH.NRESTRUTGEREN   NRGEREN,
                        EHL.NMRAZSOCESTRUT RAZAOLEGAL,
                        EHL.CDCNPJESTRUT   CNPJLEGAL,
                        EML.CDINTESTRUTURA INTLEGAL,
                        EHG.NMRAZSOCESTRUT RAZAOGEREN,
                        EHG.CDCNPJESTRUT   CNPJGEREN,
                        EMG.CDINTESTRUTURA INTGEREN
                      FROM GPE_VINCULOM VM
                      JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                                          AND VH.NRVINCULOM = VM.NRVINCULOM
                                          AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                                    WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                                      AND NRORG      = VM.NRORG
                                                                      AND NRVINCULOM = VM.NRVINCULOM )
                      /*ESTRUTURA LEGAL*/
                      JOIN ESTRUTURAM EML ON EML.NRORG        = VH.NRORG
                                              AND EML.NRESTRUTURAM = VH.NRESTRUTLEGAL
                      LEFT JOIN ESTRUTURAH EHL ON EHL.NRORG        = VH.NRORG
                                              AND EHL.NRESTRUTURAM = EML.NRESTRUTURAM
                                              AND EHL.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                                         WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                                           AND NRORG        = VH.NRORG
                                                                           AND NRESTRUTURAM = EML.NRESTRUTURAM )
                      /*ESTRUTURA GERENCIAL*/
                      JOIN ESTRUTURAM EMG ON EMG.NRORG        = VH.NRORG
                                              AND EMG.NRESTRUTURAM = VH.NRESTRUTGEREN
                      LEFT JOIN ESTRUTURAH EHG ON EHG.NRORG        = VH.NRORG
                                              AND EHG.NRESTRUTURAM = EMG.NRESTRUTURAM
                                              AND EHG.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                                         WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                                           AND NRORG        = VH.NRORG
                                                                           AND NRESTRUTURAM = EMG.NRESTRUTURAM )
                      /*CÁLCULO DE FOLHA*/
                      JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG       = VM.NRORG
                                               AND ICF.NRVINCULOM  = VM.NRVINCULOM
                                               AND ICF.NREVENTOM IN (1130, 1160, 1150, 1180, 1200, 4000, 3070 ,3075 ,3130, 3190, 3211, 4010/*1140,1190*/)
                      JOIN FPA_CALCULOFOLHA CF ON CF.NRORG            = ICF.NRORG
                                              AND CF.NRCALCULOFOLHA   = ICF.NRCALCULOFOLHA
                                              /*MOVIMENTO_TIPO*/
                                              AND CF.NRTPMODALIDCAL = :P_MODALIDADECAL
                                              AND CF.DTOCORRENCIA   = :P_COMPETENCIA
                                              AND (CF.NROCORRECAL = :P_OCORRECAL OR :P_IGNORAOCORR = 'S')
                      /**/
                      WHERE VM.NRORG = :P_NRORG
                        AND ( INSTR(','||:P_NRVINCULO||',', ','||VM.NRVINCULOM||',' ) > 0 OR :P_NRVINCULO IS NULL ) --[15-02-12][multisearch_vinculo_156497]
                        AND ( VM.DTRESCISAOVINC >= :P_COMPETENCIA OR VM.DTRESCISAOVINC IS NULL OR 1 = 1)
                        AND ( INSTR(','||:P_NRESTRUTLEGAL||',', ','||VH.NRESTRUTLEGAL||',' ) > 0 OR :P_NRESTRUTLEGAL IS NULL )
                        AND ( INSTR(','||:P_NRESTRUTGEREN||',', ','||VH.NRESTRUTGEREN||',' ) > 0 OR :P_NRESTRUTGEREN IS NULL )
                      GROUP BY VM.NRORG, VM.NRPESSOA, VM.NRVINCULOM,
                        VM.DTRESCISAOVINC,
                        VM.CDMATRICULA,
                        VM.DSLIVROADMISSAO,
                        VM.NMVINCULOM,
                        /*ICF.NREVENTOM,*/
                        CF.DTOCORRENCIA,
                        VH.NRESTRUTLEGAL,
                        VH.NRESTRUTGEREN,
                        EHL.NMRAZSOCESTRUT,
                        EHL.CDCNPJESTRUT,
                        EML.CDINTESTRUTURA,
                        EHG.NMRAZSOCESTRUT,
                        EHG.CDCNPJESTRUT,
                        EMG.CDINTESTRUTURA
                        ) RES
                  LEFT JOIN ESO_ENVIOCADASTROS ENVIO ON ENVIO.NRORG = RES.NRORG
                                                    AND TRUNC(ENVIO.DTMESCOMPETENC, 'MM') = RES.DTOCORRENCIA
                                                    AND ENVIO.NRTPAMBIENTE = 1
                                                    AND ENVIO.IDATIVO = 'S' AND ENVIO.NRENVIOEXCL IS NULL 
                                                    /*MOVIMENTO_ESOCIAL*/
                                                    AND ENVIO.IDSTATUS IN('C','A','M')
                                                    AND (ENVIO.NRTABELA = :P_NRTABELA OR :P_NRTABELA IS NULL)
                  JOIN GPE_PESSOAH PE
                           ON PE.NRPESSOA = RES.NRPESSOA 
                          AND PE.NRORG = RES.NRORG 
                          AND PE.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH 
                                                    WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                      AND NRORG = PE.NRORG
                                                      AND NRPESSOA = PE.NRPESSOA)
                  LEFT JOIN ESO_EVENTO EVESO ON EVESO.NREVENTO = ENVIO.NREVENTO
                                            AND EVESO.NMEVENTO IN ('S-2299','S-2399','S-1200')
                  WHERE ((EVESO.NMEVENTO = 'S-1200' AND ENVIO.NRCHAVE = RES.NRPESSOA) OR (EVESO.NMEVENTO IN ('S-2299','S-2399') AND ENVIO.NRCHAVE = RES.VINCULO))
                  GROUP BY RES.VINCULO,
            RES.DTRESCISAOVINC,
            RES.MATRICULA,
            RES.REGISTRO,
            PE.NRCPFPESSOA,
            RES.NOME,
            RES.NRLEGAL,
            RES.NRGEREN,
            RES.RAZAOLEGAL,
            RES.CNPJLEGAL,
            RES.INTLEGAL,
            RES.RAZAOGEREN,
            RES.CNPJGEREN,
            RES.INTGEREN,
            RES.BASE,
            RES.INSS,
            ENVIO.IDSTATUS,
            ENVIO.NRTABELA
            )
            ORDER BY CASE WHEN VRCALCULADO_ESO IS NULL THEN 1 ELSE 2 END DESC, VRCALCULADO_ESO DESC, NOME ASC";
    
    public function getContribuicaoPrevidenciariaSegurado($parameters)
    {
        $sql = $this->entityManager->getConnection()->prepare(self::$queryContribuicaoPrevidenciaria);
        $sql->execute(
            array( 'P_NRORG'         => $parameters['NRORG'],
                   'P_MODALIDADECAL' => 1,
                   'P_IGNORAOCORR'   => 'N',
                   'P_NRESTRUTGEREN' => $parameters['NRESTRUTGEREN'],
                   'P_OCORRECAL'     => 1,
                   'P_COMPETENCIA'   => $parameters['DTMESCOMPETENC'],
                   'P_NRESTRUTLEGAL' => is_array($parameters['NRESTRUTLEGAL']) ? implode(",",$parameters['NRESTRUTLEGAL']) : $parameters['NRESTRUTLEGAL'],
                   'P_NRVINCULO'     => '',
                   'P_NRTABELA'      => $parameters['NRTABELA'] )
        );
        return $sql->fetchAll();
    }
} 
