-----------------------------------
-- ESO_VERSAO --
-----------------------------------
CREATE TABLE ESO_VERSAO (
	NRVERSAO		NUMBER			NOT NULL,
	DSVERSAO		VARCHAR2(10)	NOT NULL,
	IDATIVO			VARCHAR2(1)		DEFAULT 'S' NOT NULL
		CONSTRAINT CKC_IDATIVO_ESO_VERSAO CHECK (IDATIVO IN ('S','N')),
	NRORG			NUMBER			NOT NULL,
	DTINCLUSAO		DATE			NULL,
	DTULTATU		DATE			NULL,
	NRORGINCLUSAO	NUMBER			DEFAULT 1 NULL,
	CDOPERINCLUSAO	VARCHAR2(12)	DEFAULT '1' NULL,
	NRORGULTATU		NUMBER			DEFAULT 1 NULL,
	CDOPERULTATU	VARCHAR2(12)	DEFAULT '1',
  CONSTRAINT PK_ESO_VERSAO PRIMARY KEY (NRVERSAO)
)
/

INSERT INTO ESO_VERSAO VALUES (1, '2.3', 'N', 0, SYSDATE, NULL, 1, '1', 1, '1')
/
INSERT INTO ESO_VERSAO VALUES (2, '2.4.01', 'N', 0, SYSDATE, NULL, 1, '1', 1, '1')
/
INSERT INTO ESO_VERSAO VALUES (3, '2.4.02', 'N', 0, SYSDATE, NULL, 1, '1', 1, '1')
/
INSERT INTO ESO_VERSAO VALUES (4, '2.5.00', 'S', 0, SYSDATE, NULL, 1, '1', 1, '1')
/
INSERT INTO ESO_VERSAO VALUES (5, 'S-1.0', 'S', 0, SYSDATE, NULL, 1, '1', 1, '1')
/

-----------------------------------
-- ESO_EVENTO --
-----------------------------------
UPDATE ESO_EVENTO SET IDATIVO = 'N' WHERE DSVERSAO = '2.4.02'
/

INSERT INTO ESO_EVENTO
    (NREVENTO,DSEVENTO,NMEVENTO,IDGRUPO,DSVERSAO,NRORG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,IDATIVO,IDENVAUTO,NMEVPRECED,NMEVDEPEND,NMSCHEMAXSD)
 VALUES
    ('183','S-2200 - Cadastramento Inicial do Vínculo e Admissão/Ingresso de Trabalhador','S-2200','N','S-1.0','0',SYSDATE,NULL,'1','1','1','1','S','S',null,null,null)
/

-----------------------------------
-- ESO_NAOPERIODICO --
-----------------------------------
CREATE TABLE ESO_NAOPERIODICO
(
	NRORG			NUMBER			NOT NULL,
	NRENVIO			NUMBER		 	NOT NULL,
	NRESTRUTURAM	NUMBER        	NOT NULL,
	NRVINCULOM		NUMBER		 	NOT NULL,
	NMEVENTO		VARCHAR2(6)	 	NOT NULL,
	DSVERSAO		VARCHAR2(10)	NOT NULL,
	NRTPAMBIENTE	NUMBER			NOT NULL,
	NRCHAVE			NUMBER        	NULL,
	DTMESCOMPETENC 	DATE			NULL,
	IDEVENTO		VARCHAR2(50)	NULL,
	IDOPERACAO		VARCHAR2(1)		NULL
		CONSTRAINT CKC_IDOPER_ESO_NAOPER CHECK (IDOPERACAO IN ('I','A','E')),
	DTENVIO			DATE			NULL,
	DTRESPOSTA		DATE			NULL,
	DTPROCESSAMENTO	DATE			NULL,
	IDSTATUS		VARCHAR2(1)		NULL,
	IDATIVO			VARCHAR2(1)		DEFAULT 'S' NOT NULL
		CONSTRAINT CKC_IDATIVO_ESO_NAOPER CHECK (IDATIVO IN ('S','N')),
	CDERRO			VARCHAR(10) 	NULL,
	NRPROTOCOLO		VARCHAR2(50)    NULL,
	NRRECIBO		VARCHAR2(50)    NULL,
	DSDIRXMLENV		VARCHAR2(100)	NULL,
	DSDIRXMLRETENV	VARCHAR2(100)	NULL,
	DSDIRXMLRETPRO	VARCHAR2(100)	NULL,
	DSDIRXMLRETTOT	VARCHAR2(100)	NULL,
	DSOBSERVACAO	VARCHAR2(1000)	NULL,
	DSOBSERVACAO2	VARCHAR2(1000)	NULL,
	NRENVIOEXCL		NUMBER			NULL,
	VRBASEMENSAL	FLOAT			NULL,
	VRBASE13		FLOAT			NULL,
	VRVALORMENSAL	FLOAT			NULL,
	VRVALOR13		FLOAT			NULL,
	VRVALORMATERMENSAL	FLOAT		NULL,
	VRVALORMATER13	FLOAT			NULL,
	VRSALFAMILIA	FLOAT			NULL,
	VRSALFAMILIA13	FLOAT			NULL,
	VRCALCULADO		FLOAT			NULL,
	VRDESCONTADO	FLOAT			NULL,
	NRESTRUTLOTACAO	NUMBER			NULL,
	DTINCLUSAO		DATE			NULL,
	DTULTATU		DATE			NULL,
	NRORGINCLUSAO	NUMBER			DEFAULT 1 NULL,
	CDOPERINCLUSAO	VARCHAR2(12)	DEFAULT '1' NULL,
	NRORGULTATU		NUMBER			DEFAULT 1 NULL,
	CDOPERULTATU	VARCHAR2(12)	DEFAULT '1',
  CONSTRAINT PK_ESO_NAOPER PRIMARY KEY (NRORG, NRENVIO)
)
/

ALTER TABLE ESO_NAOPERIODICO
	ADD CONSTRAINT FK_NAOPER_ESTRUT FOREIGN KEY (NRESTRUTURAM, NRORG)
		REFERENCES ESTRUTURAM (NRESTRUTURAM, NRORG)
/

ALTER TABLE ESO_NAOPERIODICO
	ADD CONSTRAINT FK_NAOPER_VINC FOREIGN KEY (NRVINCULOM, NRORG)
		REFERENCES GPE_VINCULOM (NRVINCULOM, NRORG)
/

-----------------------------------
-- PTO_TIPOJORNADA --
-----------------------------------
INSERT INTO PTO_TIPOJORNADA VALUES (10, 'Jornada com horário diário fixo e folga fixa (no domingo)', 4, 0, 'S', SYSDATE, NULL, 1, '1', 1, '1')
/
INSERT INTO PTO_TIPOJORNADA VALUES (11, 'Jornada com horário diário fixo e folga fixa (exceto no domingo)', 5, 0, 'S', SYSDATE, NULL, 1, '1', 1, '1')
/
INSERT INTO PTO_TIPOJORNADA VALUES (12, 'Jornada com horário diário fixo e folga fixa (em outro dia da semana), com folga adicional periódica no domingo', 6, 0, 'S', SYSDATE, NULL, 1, '1', 1, '1')
/
INSERT INTO PTO_TIPOJORNADA VALUES (13, 'Turno ininterrupto de revezamento', 7, 0, 'S', SYSDATE, NULL, 1, '1', 1, '1')
/

/* APLICAR SOMENTE QUANDO ENCERRAR A VERSÃO 2.5 
UPDATE PTO_TIPOJORNADA SET CDESOCIAL = 4 WHERE NRTPJORNADA = 1;
UPDATE PTO_TIPOJORNADA SET IDATIVO = 'N' WHERE NRTPJORNADA = 1;
*/

-----------------------------------
-- GPE_ESCALATRABH --
-----------------------------------
ALTER TABLE GPE_ESCALATRABH ADD IDHORNOTURNO VARCHAR2(1) DEFAULT 'N' NOT NULL
    CONSTRAINT CKC_IDHORNOT_ESCALA CHECK (IDHORNOTURNO IN ('N','S'));