/*----------------------------------------------------------------------------*/
/* Teknisa Sistemas Integrados                                                */
/* 2871_PEDSTPS_GRAVA_COMPOSICAO_BDL.SQL                                      */
/* Autor: Diego Gonalves                                                     */
/* Data: 26/01/2010                                                           */
/* Descrio:                                                                 */
/*    Rotina para inserir produtos na tabela TRAB_SUGCOMPRA.                  */
/*----------------------------------------------------------------------------*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'GRAVA_COMPOSICAO_BDL ' AND
                 TYPE = 'P' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP PROCEDURE GRAVA_COMPOSICAO_BDL
GO

CREATE PROCEDURE GRAVA_COMPOSICAO_BDL (@P_CDFILIAL         VARCHAR(4),
                                       @P_CDPRODUTO        VARCHAR(10),
                                       @P_QTPRODUTO        DOUBLE PRECISION,
                                       @P_DATAATUAL        DATETIME,
                                       @P_NRCHAVE          VARCHAR(20),
                                       @P_DTENTINI         DATETIME,
                                       @P_DTENTFIN         DATETIME,
                                       @P_DTPEDFIN         DATETIME,
                                       @P_DTPEDINI          DATETIME,
                                       @P_CDFILIDEST        VARCHAR(4),
                                       @P_CDCLIENTE         VARCHAR(21),
                                       @P_IDSITITEMPED      VARCHAR(10))
AS
BEGIN
   /*VALOR DO CUSTO DA COMPOSIO DO PRODUTO*/
   DECLARE @V_COTLOCAL        DOUBLE PRECISION;
   DECLARE @V_COTPADRAO       DOUBLE PRECISION;
   DECLARE @V_CDPRODUTO       VARCHAR(10);
   DECLARE @V_CDSUBPRODLOC    VARCHAR(10);
   DECLARE @V_QTSUBPRODLOC    DOUBLE PRECISION;
   DECLARE @V_CDSUBPRODUTO    VARCHAR(10);
   DECLARE @V_QTSUBPRODROT    DOUBLE PRECISION;
   DECLARE @V_QTPRODCOMP      DOUBLE PRECISION;

   /*SUGESTO DE COMPRAS DA COMPOSIO*/
   DECLARE @V_NRITESUGCOMP    VARCHAR(10);
   DECLARE @V_COUNTNRITE      DOUBLE PRECISION;
   DECLARE @V_QTCOMPRA        DOUBLE PRECISION;
   DECLARE @V_QTESTPRODUTO    DOUBLE PRECISION;
   DECLARE @V_QTSOLICITA      DOUBLE PRECISION;
   DECLARE @V_QTPEDIDO        DOUBLE PRECISION;
   DECLARE @V_QTESTSEGU       DOUBLE PRECISION;
   DECLARE @V_QTPREVICOMP     DOUBLE PRECISION;
   DECLARE @V_CDPRODUTOSUG    VARCHAR(10);
   DECLARE @V_CDARVPRODSUG    VARCHAR(10);
   DECLARE @V_COUNTSUGCOMP    DOUBLE PRECISION;
   DECLARE @V_QTSAIDAANT      DOUBLE PRECISION;
END
GO

ALTER PROCEDURE GRAVA_COMPOSICAO_BDL (@P_CDFILIAL         VARCHAR(4),
                                       @P_CDPRODUTO       VARCHAR(10),
                                       @P_QTPRODUTO       DOUBLE PRECISION,
                                       @P_DATAATUAL       DATETIME,
                                       @P_NRCHAVE         VARCHAR(20),
                                       @P_DTENTINI        DATETIME,
                                       @P_DTENTFIN        DATETIME,
                                       @P_DTPEDFIN        DATETIME,
                                       @P_DTPEDINI        DATETIME,
                                       @P_CDFILIDEST      VARCHAR(4),
                                       @P_CDCLIENTE       VARCHAR(21),
                                       @P_IDSITITEMPED    VARCHAR(10))
AS
BEGIN
   /*VALOR DO CUSTO DA COMPOSIO DO PRODUTO*/
   DECLARE @V_COTLOCAL        DOUBLE PRECISION;
   DECLARE @V_COTPADRAO       DOUBLE PRECISION;
   DECLARE @V_CDPRODUTO       VARCHAR(10);
   DECLARE @V_CDSUBPRODLOC    VARCHAR(10);
   DECLARE @V_QTSUBPRODLOC    DOUBLE PRECISION;
   DECLARE @V_CDSUBPRODUTO    VARCHAR(10);
   DECLARE @V_QTSUBPRODROT    DOUBLE PRECISION;
   DECLARE @V_QTPRODCOMP      DOUBLE PRECISION;

   /*SUGESTO DE COMPRAS DA COMPOSIO*/
   DECLARE @V_NRITESUGCOMP    VARCHAR(10);
   DECLARE @V_COUNTNRITE      DOUBLE PRECISION;
   DECLARE @V_QTCOMPRA        DOUBLE PRECISION;
   DECLARE @V_QTESTPRODUTO    DOUBLE PRECISION;
   DECLARE @V_QTSOLICITA      DOUBLE PRECISION;
   DECLARE @V_QTPEDIDO        DOUBLE PRECISION;
   DECLARE @V_QTESTSEGU       DOUBLE PRECISION;
   DECLARE @V_QTPREVICOMP     DOUBLE PRECISION;
   DECLARE @V_CDPRODUTOSUG    VARCHAR(10);
   DECLARE @V_CDARVPRODSUG    VARCHAR(10);
   DECLARE @V_COUNTSUGCOMP    DOUBLE PRECISION;
   DECLARE @V_QTSAIDAANT      DOUBLE PRECISION;

   SET @V_QTPRODCOMP = 0;
   /*Verifica se existe composio Local para o produto informado.*/
   SELECT @V_COTLOCAL = COUNT(*)
     FROM ROTFABLOCAL R
    WHERE (R.CDFILIAL  = @P_CDFILIAL )
      AND (R.CDPRODUTO = @P_CDPRODUTO);

   IF @V_COTLOCAL > 0 BEGIN
      /* Composio Local */
      DECLARE C_COMPLOCAL CURSOR FOR
      SELECT R.CDPRODUTO, R.CDSUBPRODLOC, R.QTSUBPRODLOC
         FROM ROTFABLOCAL R
        WHERE (R.CDFILIAL  = @P_CDFILIAL )
          AND (R.CDPRODUTO = @P_CDPRODUTO)
        ORDER BY R.NRSEQPRODLOC;
      OPEN C_COMPLOCAL;
      FETCH NEXT FROM C_COMPLOCAL INTO @V_CDPRODUTO, @V_CDSUBPRODLOC, @V_QTSUBPRODLOC;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_QTPRODCOMP = (@V_QTSUBPRODLOC * @P_QTPRODUTO);
         EXECUTE TEKNISA.GRAVA_COMPOSICAO_BDL @P_CDFILIAL, @V_CDSUBPRODLOC, @V_QTPRODCOMP, @P_DATAATUAL,
                                              @P_NRCHAVE, @P_DTENTINI, @P_DTENTFIN, @P_DTPEDFIN, @P_DTPEDINI, @P_CDFILIDEST, @P_CDCLIENTE, @P_IDSITITEMPED;

         FETCH NEXT FROM C_COMPLOCAL INTO @V_CDPRODUTO, @V_CDSUBPRODLOC, @V_QTSUBPRODLOC;
      END;
      CLOSE C_COMPLOCAL;
      DEALLOCATE C_COMPLOCAL;
   END
   ELSE BEGIN
      /*Verifica se existe composio Padro para o produto informado.*/
      SELECT @V_COTPADRAO = COUNT(*)
        FROM ROTFABRICA R
       WHERE (R.CDPRODUTO = @P_CDPRODUTO);

      IF @V_COTPADRAO > 0 BEGIN
         /*Composio Padro*/
         DECLARE C_COMPPADRAO CURSOR FOR
         SELECT R.CDPRODUTO, R.CDSUBPRODUTO, R.QTSUBPRODROT
            FROM ROTFABRICA R
           WHERE (R.CDPRODUTO = @P_CDPRODUTO)
           ORDER BY R.CDPRODUTO;
         OPEN C_COMPPADRAO;
         FETCH NEXT FROM C_COMPPADRAO INTO @V_CDPRODUTO, @V_CDSUBPRODUTO, @V_QTSUBPRODROT;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SET @V_QTPRODCOMP = (@V_QTSUBPRODROT * @P_QTPRODUTO);
            EXECUTE TEKNISA.GRAVA_COMPOSICAO_BDL @P_CDFILIAL, @V_CDSUBPRODUTO, @V_QTPRODCOMP, @P_DATAATUAL,
                                                 @P_NRCHAVE, @P_DTENTINI, @P_DTENTFIN,  @P_DTPEDFIN, @P_DTPEDINI, @P_CDFILIDEST, @P_CDCLIENTE, @P_IDSITITEMPED;

            FETCH NEXT FROM C_COMPPADRAO INTO @V_CDPRODUTO, @V_CDSUBPRODUTO, @V_QTSUBPRODROT;
         END;
         CLOSE C_COMPPADRAO;
         DEALLOCATE C_COMPPADRAO;
      END
      ELSE BEGIN
         SELECT @V_NRITESUGCOMP = ISNULL(MAX(NRITESUGCOMP), 0), @V_COUNTNRITE = ISNULL(COUNT(NRITESUGCOMP), 0)
           FROM TRAB_SUGCOMPRA
          WHERE CDFILSUGCOMP = @P_CDFILIAL
            AND NRSUGCOMPRA  = @P_NRCHAVE;

         SELECT @V_QTPEDIDO  =   (SELECT (ISNULL((SELECT DISTINCT SUM(IT.QTITEMPED - IT.QTEXPITEMPED) 
                                    FROM ITEMPEDIDO IT, PEDIDO P
                                   WHERE IT.CDPRODUTO = @P_CDPRODUTO  
                                     AND CHARINDEX(IT.IDSITITEMPED, @P_IDSITITEMPED) > 0
                                     AND IT.CDFILIAL = @P_CDFILIAL
                                     AND IT.CDFILIAL = P.CDFILIAL
                                     AND IT.NRPEDIDO = P.NRPEDIDO                                
                                     AND ((CONVERT(DATETIME, IT.DTENTITPED, 103)BETWEEN @P_DTENTINI  AND @P_DTENTFIN)OR((@P_DTENTINI IS NULL) AND(@P_DTENTFIN IS NULL)))
                                     AND P.IDSITPEDIDO IN('1','2','3','6')                                
                                     AND ((P.DTPEDIDO BETWEEN @P_DTPEDINI  AND @P_DTPEDFIN)OR((@P_DTPEDINI IS NULL) AND(@P_DTPEDFIN IS NULL)))
                                     AND ((@P_CDCLIENTE IS NULL)OR(CHARINDEX(P.CDCLIENTE, @P_CDCLIENTE)>0))
                                     AND ((@P_CDFILIDEST IS NULL)OR( CHARINDEX(P.CDFILIALPED, @P_CDFILIDEST)>0))
                                     AND NOT EXISTS(SELECT K.NRPEDIDO
                                                      FROM PEDIDOP K
                                                     WHERE K.CDFILIAL = IT.CDFILIAL 
                                                       AND K.NRPEDIDO = IT.NRPEDIDO 
                                                       AND K.NRITEMPED = IT.NRITEMPED)), 0))),
                                 
                @V_QTESTSEGU = (SELECT SUM(ISNULL(QTESTOSEGU, 0))
                                  FROM ESTOSEGU
                                 WHERE CDFILIAL = @P_CDFILIAL 
                                   AND CDPRODESTO = U.CDPRODESTO),
                                   
                @V_QTPREVICOMP = (SELECT SUM(ISNULL(QTPREVCOMP,0))
                                    FROM ITPREVCOMP C
                                   WHERE C.IDSTITPRCOMP = ('A')
                                     AND ((C.DTENTPRECOMP BETWEEN @P_DTENTINI  AND @P_DTENTFIN)OR((@P_DTENTINI IS NULL) AND(@P_DTENTFIN IS NULL)))
                                     AND @P_CDFILIAL   = C.CDFILIAL  
                                     AND @P_CDPRODUTO  = C.CDPRODUTO),
                                     
                @V_QTSOLICITA = (SELECT (ISNULL((SELECT SUM(ISNULL(IL.QTSOLIPROD, 0)) 
                                                      FROM SOLICITA S, ITEMSOLI IL
                                                     WHERE @P_CDFILIAL  = IL.CDFILSOLI 
                                                       AND @P_CDPRODUTO = IL.CDPRODUTO 
                                                       AND (S.IDBAIXASOL IS NULL)          
                                                       AND ((IL.DTPROGENTR BETWEEN @P_DTENTINI  AND @P_DTENTFIN)OR((@P_DTENTINI IS NULL) AND(@P_DTENTFIN IS NULL)))
                                                       AND IL.CDFILSOLI  = S.CDFILSOLI
                                                       AND IL.CDFILLAN   = S.CDFILLANCA
                                                       AND IL.NRSOLICMP  = S.NRSOLICMP ), 0))),
                                    
                @V_QTESTPRODUTO = (SELECT SUM(ISNULL(QTTOTALESTOQ,0))* ISNULL(U.VRFATOCONV, 1)
                                     FROM POSESTATU PA
                                    WHERE @P_CDFILIAL   = PA.CDFILIAL  
                                      AND U.CDPRODUTO  = PA.CDPRODUTO 
                                      AND PA.CDALMOXARIFE =  TEKNISA.BUSCA_ALMOX(@P_CDFILIAL, '', U.CDPRODUTO)
                                      AND PA.CDLOCALESTOQ =  TEKNISA.BUSCA_LOCAL(@P_CDFILIAL, '', U.CDPRODUTO )),
                                      
                @V_CDPRODUTOSUG = U.CDPRODUTO, @V_CDARVPRODSUG = U.CDARVPROD
                
           FROM PRODUTO U
          WHERE U.CDPRODUTO = @P_CDPRODUTO
          GROUP BY U.CDPRODUTO, U.CDARVPROD, U.CDPRODESTO, U.VRFATOCONV;

         SET @V_QTCOMPRA = ISNULL(@V_QTESTPRODUTO, 0) + ISNULL(@V_QTSOLICITA, 0) - (ISNULL(@V_QTPEDIDO, @P_QTPRODUTO) + ISNULL(@V_QTESTSEGU, 0) + ISNULL(@V_QTPREVICOMP, 0));

         IF @V_QTCOMPRA > 0 BEGIN
            SET @V_QTCOMPRA = 0;
         END
         ELSE BEGIN
            SET @V_QTCOMPRA = @V_QTCOMPRA * (-1);
         END;

         SET @V_COUNTSUGCOMP = 0;

         SELECT @V_COUNTSUGCOMP = COUNT(*)
           FROM TRAB_SUGCOMPRA
          WHERE CDFILSUGCOMP = @P_CDFILIAL
            AND NRSUGCOMPRA = @P_NRCHAVE
            AND CDPROSUGCOMP = @P_CDPRODUTO;

         IF ISNULL(@V_QTPEDIDO, @P_QTPRODUTO) > 0 BEGIN
            SET @V_QTSAIDAANT = ISNULL(@V_QTPEDIDO, @P_QTPRODUTO);
         END
         ELSE BEGIN
            SET @V_QTSAIDAANT = 0;
         END;

         IF @V_COUNTSUGCOMP = 0 BEGIN
            INSERT INTO TRAB_SUGCOMPRA
                   (CDFILSUGCOMP, NRSUGCOMPRA, CDPROSUGCOMP, DTREFSUGCOMP, QTCOMPRA,
                   QTSAIDAANT01, QTSAIDAANT02, QTSAIDAANT03, QTSAIDAATUAL, QTMEDIAMES, NRITESUGCOMP)
            VALUES
                   (@P_CDFILIAL , @P_NRCHAVE, @P_CDPRODUTO, @P_DATAATUAL, @V_QTCOMPRA,
                   @V_QTSAIDAANT, @V_QTESTPRODUTO, @V_QTESTSEGU, @V_QTSOLICITA, @V_QTPREVICOMP, RIGHT(REPLICATE ('0',10) + CONVERT(VARCHAR, ISNULL(CONVERT(INTEGER, @V_NRITESUGCOMP), @V_COUNTNRITE) + 1),10));
         END
         ELSE BEGIN
            UPDATE TRAB_SUGCOMPRA
               SET QTCOMPRA     = QTCOMPRA + @V_QTCOMPRA,
                   QTSAIDAANT01 = QTSAIDAANT01 + ISNULL(@V_QTPEDIDO, @P_QTPRODUTO),
                   QTSAIDAANT02 = QTSAIDAANT02 + @V_QTESTPRODUTO,
                   QTSAIDAANT03 = QTSAIDAANT03 + @V_QTESTSEGU,
                   QTSAIDAATUAL = QTSAIDAATUAL + @V_QTSOLICITA,
                   QTMEDIAMES   = QTMEDIAMES + @V_QTPREVICOMP
             WHERE CDFILSUGCOMP = @P_CDFILIAL
               AND NRSUGCOMPRA  = @P_NRCHAVE
               AND CDPROSUGCOMP = @P_CDPRODUTO;
         END;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_COMPOSICAO_BDL','5.09.014';
GO
